From ed4c09c0c4519469b283d55a282f12b33184c699 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 29 2016 15:10:44 +0000
Subject: [PATCH 351/1001] Getting closer to a running cache invalidator.


---

diff --git a/fedmsg.d/logging.py b/fedmsg.d/logging.py
index c31901c..3502cd9 100644
--- a/fedmsg.d/logging.py
+++ b/fedmsg.d/logging.py
@@ -19,22 +19,27 @@ config = dict(
                 "stream": "ext://sys.stdout",
             },
         ),
-        loggers=dict(
-            fedmsg={
+        loggers={
+            "fedmsg": {
                 "level": "INFO",
                 "propagate": False,
                 "handlers": ["console"],
             },
-            moksha={
+            "moksha": {
                 "level": "INFO",
                 "propagate": False,
                 "handlers": ["console"],
             },
-            hubs={
+            "hubs": {
                 "level": "DEBUG",
                 "propagate": False,
                 "handlers": ["console"],
             },
-        ),
+            "fmn.rules": {
+                "level": "ERROR",
+                "propagate": False,
+                "handlers": ["console"],
+            }
+        },
     ),
 )
diff --git a/fedmsg.d/testconfig.py b/fedmsg.d/testconfig.py
index ec13c43..e85072e 100644
--- a/fedmsg.d/testconfig.py
+++ b/fedmsg.d/testconfig.py
@@ -25,6 +25,15 @@ config = {
         },
     },
 
+    # Some configuration for the general hubs cache.
+    "fedora-hubs.cache": {
+        "backend": "dogpile.cache.dbm",
+        "expiration_time": -1,  # Expire every 1 second, for development
+        "arguments": {
+            "filename": "/var/tmp/fedora-hubs-cache.db",
+        },
+    },
+
     # Run datanommer locally, just for development.
     'datanommer.enabled': True,
     'datanommer.sqlalchemy.url': 'postgres://postgres:laksjdf@127.0.0.1/datanommer',
diff --git a/hubs/consumer.py b/hubs/consumer.py
index bd7345e..6e938ae 100755
--- a/hubs/consumer.py
+++ b/hubs/consumer.py
@@ -4,11 +4,14 @@ import collections
 import threading
 import time
 
+import munch
+
 import datanommer.models
 import fedmsg.consumers
 import fedmsg.meta
 
 import hubs.models
+import hubs.widgets
 
 from hubs.widgets.base import invalidate_cache
 
@@ -16,6 +19,17 @@ import logging
 log = logging.getLogger("hubs")
 
 
+def j(widget):
+    """ Shorthand to reduce a sqlalchemy widget to a munch for processing. """
+    return munch.Munch(dict(
+        idx=widget.idx,
+        hub_id=widget.hub_id,
+        plugin=widget.plugin,
+        config=widget.config,
+        # TODO -- add other things here as we need it
+    ))
+
+
 class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
     topic = '*'
     config_key = 'hubs.consumer.enabled'
@@ -50,29 +64,37 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         self.checks_by_topic = collections.defaultdict(list)
         self.checks_by_category = collections.defaultdict(list)
         self.checks_by_username = collections.defaultdict(list)
+        self.ubiquitous_checks = list()
 
         widgets = session.query(hubs.models.Widget).all()
         log.info("Building lookup from  %i total widgets" % len(widgets))
         for widget in widgets:
-            check = widget.module.should_invalidate
+            module = hubs.widgets.registry[widget.plugin]
+            check = module.should_invalidate
 
             if not hasattr(check, 'hints'):
-                raise AttributeError("%r must declare hints" % widget.module)
+                raise AttributeError("%r must declare hints" % module)
+
+            item = (check, j(widget),)
 
             for topic in check.hints['topics']:
-                self.checks_by_topic[topic].append((check, widget,))
+                self.checks_by_topic[topic].append(item)
 
             for category in check.hints['categories']:
-                self.checks_by_category[category].append((check, widget,))
+                self.checks_by_category[category].append(item);
 
             usernames = check.hints['usernames_function'](widget)
             for username in usernames:
-                self.checks_by_username[username].append((check, widget,))
+                self.checks_by_username[username].append(item)
+
+            if check.hints['ubiquitous']:
+                self.ubiquitous_checks.append(item)
 
         log.info("Lookup sizes are:")
         log.info("- %i topics" % len(self.checks_by_topic))
         log.info("- %i categories" % len(self.checks_by_category))
         log.info("- %i usernames" % len(self.checks_by_username))
+        log.info("- %i ubiquitous" % len(self.ubiquitous_checks))
 
     @property
     def lookup_initialized(self):
@@ -86,10 +108,13 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         except:
             session.rollback()  # rolls back the transaction
             raise
+        finally:
+            session.close()
 
     def work(self, session, raw_msg):
         topic, msg = raw_msg['topic'], raw_msg['body']
         category = topic.split('.')[3]
+        usernames = fedmsg.meta.msg2usernames(msg, **self.hub.config)
 
         for suffix in self.junk_suffixes:
             if topic.endswith(suffix):
@@ -111,9 +136,12 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
 
         # Start this by finding a subset of widget checks that might match this
         # message. Look them up based on the hints they declare.
-        checks = set(
-            self.checks_by_topic[topic] + self.checks_by_category[category]
-        )
+        checks = sum([
+            self.checks_by_topic[topic],
+            self.checks_by_category[category],
+            sum([self.checks_by_username[u] for u in usernames], []),
+            self.ubiquitous_checks,
+        ], [])
 
         statement = "Found %i checks to try for this message" % len(checks)
         if checks:
@@ -129,7 +157,8 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
                 # Invalidate the cache...
                 invalidate_cache(widget, **widget.config)
                 # Rebuild it.
-                widget.module.data(session, widget, **widget.config)
+                module = hubs.widgets.registry[widget.plugin]
+                module.data(session, widget, **widget.config)
                 # TODO -- fire off an EventSource notice that we updated stuff
 
         log.debug("Done.  %0.2fs %s %s",
diff --git a/hubs/hinting.py b/hubs/hinting.py
index b04d688..14ed445 100755
--- a/hubs/hinting.py
+++ b/hubs/hinting.py
@@ -6,11 +6,12 @@ import logging
 log = logging.getLogger('hubs.hinting')
 
 
-def hint(topics=None, categories=None, usernames=None):
+def hint(topics=None, categories=None, usernames=None, ubiquitous=False):
     topics = topics or []
     categories = categories or []
     default_usernames = lambda x: []
     usernames = usernames or default_usernames
+    ubiquitous = ubiquitous
 
     @decorator.decorator
     def wrapper(fn, *args, **kwargs):
@@ -22,6 +23,7 @@ def hint(topics=None, categories=None, usernames=None):
             topics=topics,
             categories=categories,
             usernames_function=usernames,
+            ubiquitous=ubiquitous,
         )
         return wrapped
 
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index f1f84cb..e1fd798 100755
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -77,7 +77,7 @@ def invalidate_cache(widget, *args, **kwargs):
     cache.delete(key)
 
 
-def cache_key_generator(widget, args, kwargs):
+def cache_key_generator(widget, *args, **kwargs):
     return "|".join([
         str(widget.idx),
         json.dumps(args),
diff --git a/hubs/widgets/feed.py b/hubs/widgets/feed.py
index 8ae603f..de793f5 100755
--- a/hubs/widgets/feed.py
+++ b/hubs/widgets/feed.py
@@ -1,7 +1,7 @@
 from __future__ import print_function
 
 from hubs.hinting import hint
-from hubs.widgets.base import argument
+from hubs.widgets.base import argument, cache
 from hubs.widgets import templating
 
 import fmn.lib
@@ -61,7 +61,6 @@ def apply_markup(match):
 
     return markup
 
-
 @argument(name="username",
           default=None,
           validator=validators.username,
@@ -71,15 +70,11 @@ def apply_markup(match):
           validator=validators.fmn_context,
           help="A FMN context.")
 def data(session, widget, username, fmn_context):
-    openid = '%s.id.fedoraproject.org' % username
-    url = '/'.join([fmn_url, 'api', openid, fmn_context])
-    log.info("Getting FMN preferences from %s" % url)
-    response = requests.get(url)
     messages = []
     matches = []
-    if response.status_code == 200:
-        preference = response.json()
-        preference = rehydrate_preferences(preference)
+    preference = get_remote_preference(username, fmn_context)
+    if preference:
+        preference = rehydrate_preference(preference)
 
         # The smaller we make this, the faster it is.
         delta = datetime.timedelta(days=365)
@@ -110,7 +105,7 @@ def data(session, widget, username, fmn_context):
             if recipients:
                 matches.append(original)
     else:
-        log.warn("You don't have any preferences. \n Url=%s" % url)
+        log.warn("You don't have any preferences.")
 
     # TODO - sort messages and remove duplicates
 
@@ -141,14 +136,34 @@ def data(session, widget, username, fmn_context):
     )
 
 
-@hint()
+@hint(ubiquitous=True)
 def should_invalidate(message, session, widget):
-    # only if a new message would match the FMN filters would this be
-    # invalidated... but that is as expensive as being FMN ourselves.
-    raise NotImplementedError
+    username = widget.config['username']
+    fmn_context = widget.config['fmn_context']
+    preference = get_remote_preference(username, fmn_context)
+    if not preference:
+        return False
+    preference = rehydrate_preference(preference)
+    recipients = fmn.lib.recipients([preference], message, paths, config)
+    return bool(recipients)
+
+
+# TODO -- this cache value needs its own FMN-based invalidator...
+@cache.cache_on_arguments()
+def get_remote_preference(username, fmn_context):
+    openid = '%s.id.fedoraproject.org' % username
+    url = '/'.join([fmn_url, 'api', openid, fmn_context])
+    log.info("Getting FMN preference from %s" % url)
+    response = requests.get(url)
+    if bool(response):
+        return response.json()
+    else:
+        # Some people have no FMN preferences, but when they do get some.. then
+        # we'll receive the fedmsg event about it and bust this cache value.
+        return None
 
 
-def rehydrate_preferences(preference):
+def rehydrate_preference(preference):
     for fltr in preference['filters']:
         fltr['rules'] = [munch.Munch(r) for r in fltr['rules']]
         for rule in fltr['rules']:
diff --git a/hubs/widgets/meetings.py b/hubs/widgets/meetings.py
index 37c11ee..67bdc1c 100755
--- a/hubs/widgets/meetings.py
+++ b/hubs/widgets/meetings.py
@@ -1,4 +1,4 @@
-#from hubs.hinting import hint, prefixed as _
+from hubs.hinting import hint
 from hubs.widgets.base import argument
 from hubs.widgets.chrome import panel
 from hubs.widgets import templating
@@ -68,6 +68,7 @@ def data(session, widget, calendar):
     return dict(meetings=dict(meetings))
 
 
+@hint(categories=['fedocal'])
 def should_invalidate(message, session, widget):
     # TODO -- we have a hard problem here.
     # There is no event which should invalidate this widget...
diff --git a/hubs/widgets/stats.py b/hubs/widgets/stats.py
index 7f329cf..3b784e3 100755
--- a/hubs/widgets/stats.py
+++ b/hubs/widgets/stats.py
@@ -36,7 +36,7 @@ def data(session, widget):
     )
 
 
-@hint(topics=_('hubs.hub.update'))
+@hint(topics=[_('hubs.hub.update')])
 def should_invalidate(message, session, widget):
     if message['topic'].endswith('hubs.hub.update'):
         if message['msg']['hub']['name'] == widget.hub.name:
diff --git a/hubs/widgets/subscriptions.py b/hubs/widgets/subscriptions.py
index 6d7e52f..6576516 100755
--- a/hubs/widgets/subscriptions.py
+++ b/hubs/widgets/subscriptions.py
@@ -1,4 +1,4 @@
-# from hubs.hinting import hint, prefixed as _
+from hubs.hinting import hint, prefixed as _
 from hubs.widgets.base import argument
 from hubs.widgets.chrome import panel
 from hubs.widgets import templating
@@ -9,6 +9,9 @@ import hubs.models
 
 from fedmsg.meta.base import BaseConglomerator as BC
 
+import fedmsg.config
+fm_config = fedmsg.config.load_config()
+
 import flask
 
 chrome = panel('Hubs', key='associations')
@@ -47,5 +50,8 @@ def manage_subscriptions(items):
     ]
 
 
+@hint(topics=[_('hubs.associate')])
 def should_invalidate(message, session, widget):
-    raise NotImplementedError()
+    username = widget.config['username']
+    users = fedmsg.meta.msg2usernames(message, **fm_config)
+    return username in users

